// All code Copyright (c) 2009, Nessoft, LLC.

var request;
var refreshTimerID;
var lastSplitsPulled = new Date().getTime() - 10000;
var inCompareMode = 0;

function load()
{
        request = null;
	
	if (window.XMLHttpRequest) 
	{
	// Native XMLHttpRequest object
		request = new XMLHttpRequest();
	}
	else if (window.ActiveXObject) 
	{
	// IE/Windows ActiveX version
		request = new ActiveXObject("Microsoft.XMLHTTP");
	}  else {
	  Alert('No AJAX objects available.');
	}

	fetchAndParseXml();
}

function SetHTMLIfDifferent(Element, newHTML) {
	if ((Element) && (Element.innerHTML != newHTML)) {
		Element.innerHTML = newHTML;
	}
}

function showStatusInfo(Message)
{
  var elem = document.getElementById('statusline');
  if (elem) {
    if (Message > "") {
      SetHTMLIfDifferent(elem, Message);
      elem.style.display = "block";
    } else {
      SetHTMLIfDifferent(elem, Message);
      elem.style.display = "none";
    }
  }
}

// IE and Mozilla have different kinds of error objects.  This "normalizes" so we
// can get a description in both.
function errorDescription(e) {
	var errorMessage = "";
	if ((e) && (e.name)) {
		errorMessage = e.name + ": ";
	}
	if ((e) && (e.message)) {
		errorMessage = errorMessage + e.message;
	} else if ((e) && (e.description)) {
		errorMessage = errorMessage + e.description;
	} else {
		errorMessage = errorMessage + e;
	}
	if ((e) && (e.fileName)) {
		errorMessage = errorMessage + ", file: " + e.fileName;
	}
	if ((e) && (e.lineNumber)) {
		errorMessage = errorMessage + ", line: " + e.lineNumber;
	}
	if ((e) && (e.stack)) {
		errorMessage = errorMessage + "<br>Stack Trace:<br>";
	}
	return errorMessage.replace(/\n/g,"<br>");
}


function fetchAndParseXml()
{
    request.onreadystatechange = onXmlFetched;
		var url = "/data.json?";
		// Only pull splits once a second.
		if ((new Date().getTime() - lastSplitsPulled) < 1000) {
			url += 'nosplits&CompareLine';
		} else {
		  lastSplitsPulled = new Date().getTime();
		}
    request.open("GET", url+"&_="+(new Date()).getTime(), true);
    request.send(null);
}

function formatTimeMinSecDigits(Number, Digits) {
var FormattedNum, Minutes;
  FormattedNum = '';
	Minutes = Math.floor(Number / 60);
  if (Minutes > 0) {
	  FormattedNum = Minutes.toFixed(0)+':';
	}
	FormattedNum += (Number - Minutes * 60).toFixed(Digits);
  return FormattedNum;
}

function onXmlFetched()
{
	clearTimeout(refreshTimerID);
  if (request.readyState == 4) {
	  try {

			if(request.status != 200) {
				throw('Error loading json data.  iSpeed said: ' + request.status + ' ' + request.statusText);
			}

      try {
			  var iSpeedData = eval("(" + request.responseText + ")");
			} catch(e) {
			  throw "Invalid json data - iSpeed closing?";
			}

			if (iSpeedData.splits) {
				var Optimal = 0;
				var Best = 0;
				var Delta = 0;
				var Selected = "";

				// Fill in the splits.
				var splitText = '';
				var split;
				for (var i=0; i < iSpeedData.splits.split.length; i++) {
					split = iSpeedData.splits.split[i];
					if (iSpeedData.splits.current == split.id) {
					  Selected = " cursplit";
					} else {
					  Selected = "";
					}
					splitText += '<span class="splitlabel'+Selected+'">'+split.name+': </span>';
					Best = split.best;
					Delta = split.delta;
					showStatusInfo(Best + " " + Delta);
					if (Best >= 0) {
						Optimal += Best;
						splitText += '<span class="splittime '+Selected+'">' + formatTimeMinSecDigits(Best, 3) + '</span>';
						if (Delta > -9999) {
							if (Delta <= 0) {
								splitText += '<span class="splitbetter"> (' + (Delta).toFixed(3) + ')</span>';
							} else {
								splitText += '<span class="splitworse"> (+' + (Delta).toFixed(3) + ')</span>';
							}
						}
					}
					splitText += '<br>';
				}
				splitText += '<span class="optimallabel">';
				if (inCompareMode) {
				  splitText += 'Compare Time';
				} else {
				  splitText += 'Optimal';
				}
				splitText += ': </span><span class="optimaltime">'+formatTimeMinSecDigits(Optimal, 3)+'</span>';
				SetHTMLIfDifferent(document.getElementById('splitsDisplay'), splitText);
			}

			if (iSpeedData.speed) {
				var speedDelta = iSpeedData.speed.delta;
				var speedDeltaDisp = speedDelta.toFixed(1);

				if (speedDelta >= 0) {
					speedDeltaDisp = "+" + speedDeltaDisp;
				  speedDeltaDisp = '<span class="speedfaster">'+speedDeltaDisp+'</span>';
				} else {
				  speedDeltaDisp = '<span class="speedslower">'+speedDeltaDisp+'</span>';
				}
				SetHTMLIfDifferent(document.getElementById('deltaspeedDisplay'), speedDeltaDisp);
				SetHTMLIfDifferent(document.getElementById('SpeedDisplay'), iSpeedData.speed.val.toFixed(1));
			}
			if (iSpeedData.laptime) {
				var timeDelta = Number(iSpeedData.laptime.curdelta);
				if (timeDelta > 999) { timeDelta = 999; }
				var timeDeltaStr = timeDelta.toFixed(2);
				if (timeDelta > 0.15) {
					timeDeltaStr = '+'+timeDeltaStr;
					timeDeltaStr = '<span class="timeslower">'+timeDeltaStr+'</span>';
				} else if (timeDelta < 0.00) {
					timeDeltaStr = '<span class="timefaster">'+timeDeltaStr+'</span>';
				} else {
					timeDeltaStr = '+'+timeDeltaStr;
					timeDeltaStr = '<span class="timesimilar">'+timeDeltaStr+'</span>';
				}
				SetHTMLIfDifferent(document.getElementById('deltatimeDisplay'), timeDeltaStr);
				
				SetHTMLIfDifferent(document.getElementById('lastlapDisplay'), formatTimeMinSecDigits(iSpeedData.laptime.lastlap,3));
				SetHTMLIfDifferent(document.getElementById('bestlapDisplay'), formatTimeMinSecDigits(iSpeedData.laptime.bestlap,3));
			}
			if (iSpeedData.comparemode) {
				var compareMode = document.getElementById('comparisoninfo');
				if (iSpeedData.comparemode.active) {
				  SetHTMLIfDifferent(compareMode, iSpeedData.comparemode.message);
				  compareMode.style.display = "block";
				  inCompareMode = 1;
				} else {
				  compareMode.style.display = "none";
				  inCompareMode = 0;
				}
			}
			if (iSpeedData.rpm) {
				SetHTMLIfDifferent(document.getElementById('rpmDisplay'), Number(iSpeedData.rpm / 10).toFixed(0)+'0');
			}
//			fetchAndParseXml();
			refreshTimerID = setTimeout("fetchAndParseXml()", 50);
			showStatusInfo();
		}
		catch (e) {
			// Firefox raises an exception.
			if (e.name && (e.name.toUpperCase() == "NS_ERROR_NOT_AVAILABLE")) {
				// It's a Firefox-specific error
				showStatusInfo("iSpeed not available, or page resetting...");
			} else {
 				showStatusInfo("Error loading iSpeed data.<BR>" + errorDescription(e));
 			}
		}
	}
}